package schedframe.resources.computing.coolemall;

import java.util.ArrayList;
import java.util.List;

import schedframe.resources.StandardResourceType;
import schedframe.resources.computing.Node;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.computing.Processor;
import schedframe.resources.computing.description.ComputingResourceDescription;
import schedframe.resources.computing.description.ResourceDescription;
import schedframe.resources.devices.Device;
import schedframe.resources.devices.Fan;
import test.Node_Fan_Mapping;

public class NodeGroup extends ComputingResource{
	
	public NodeGroup(ComputingResourceDescription resDesc) {
		super(resDesc);
		initNodes_FansMapping(resDesc);
	}

	@SuppressWarnings("unchecked")
	public List<Node> getNodes(){
		return (List<Node>) getDescendantsByType(StandardResourceType.Node);
	}
	
	@SuppressWarnings("unchecked")
	public List<Processor> getProcessors(){
		return (List<Processor>) getDescendantsByType(StandardResourceType.Processor);
	}

	
	private void initNodes_FansMapping(ComputingResourceDescription resDesc){
		Node_Fan_Mapping.init();
		for(Device dev: this.getResourceCharacteristic().getDevices()){
			if(dev.getType().equals(StandardResourceType.Fan) || dev.getType().equals(StandardResourceType.Inlet) | dev.getType().equals(StandardResourceType.Outlet)){
				Fan fan = (Fan) dev;
				List<String> chilledResources = new ArrayList<String>();
				for(ResourceDescription nodeDesc: resDesc.getChildren()){
					String nodeName = this.getFullName() + "/" + nodeDesc.getId();
					if(!Node_Fan_Mapping.getNode_fan().containsKey(nodeName)){
						chilledResources.add(nodeName);
					} else if(Node_Fan_Mapping.getNode_fan().get(nodeName).equals(fan.getFullName())){
						chilledResources.add(nodeName);
					} else {
						//if mapping present but there is no match do nothing
					}
				}
				fan.setChilledResources(chilledResources);
			}
		}
	}
}
